@import UIKit;
@import ObjectiveC.runtime;

void trace(NSString* message)
{
	printf("\e[32mHomeInject: %s\e[0m\n",[message UTF8String]);
}

void swizzle(Class realClass,Class fakeClass,SEL realSelector,SEL fakeSelector,bool instance)
{
	Method realMethod;
	Method fakeMethod;
	if(instance)
	{
		realMethod=class_getInstanceMethod(realClass,realSelector);
		fakeMethod=class_getInstanceMethod(fakeClass,fakeSelector);
	}
	else
	{
		realMethod=class_getClassMethod(realClass,realSelector);
		fakeMethod=class_getClassMethod(fakeClass,fakeSelector);
	}
	
	if(realMethod==nil||fakeMethod==nil)
	{
		trace(@"swizzle fail");
		return;
	}
	
	method_exchangeImplementations(realMethod,fakeMethod);
	
	trace(@"swizzle success");
}

@interface UIVibrancyEffect(FakeUIVibrancyEffect)
@end
@implementation UIVibrancyEffect(FakeUIVibrancyEffect)
+(UIVibrancyEffect*)fakeEffectForBlurEffect:(UIBlurEffect*)effect style:(UIVibrancyEffectStyle)style
{
	trace(@"UIVibrancyEffect hack");
	return [self fakeEffectForBlurEffect:effect style:UIVibrancyEffectStyleLabel];
}
@end

@interface Inject:NSObject
@end
@implementation Inject
+(void)load
{
	trace(@"loaded");
	
	swizzle(UIVibrancyEffect.class,UIVibrancyEffect.class,@selector(effectForBlurEffect:style:),@selector(fakeEffectForBlurEffect:style:),false);
}
@end